<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>LearnerZooKeeperServer.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">LearnerZooKeeperServer.java</span></div><h1>LearnerZooKeeperServer.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.zookeeper.server.quorum;

import java.io.IOException;
import java.util.HashMap;

import org.apache.zookeeper.jmx.MBeanRegistry;
import org.apache.zookeeper.server.DataTreeBean;
import org.apache.zookeeper.server.ServerCnxn;
import org.apache.zookeeper.server.ZKDatabase;
import org.apache.zookeeper.server.ZooKeeperServerBean;
import org.apache.zookeeper.server.persistence.FileTxnSnapLog;

/**
 * Parent class for all ZooKeeperServers for Learners 
 */
public abstract class LearnerZooKeeperServer extends QuorumZooKeeperServer {    
    public LearnerZooKeeperServer(FileTxnSnapLog logFactory, int tickTime,
            int minSessionTimeout, int maxSessionTimeout,
            DataTreeBuilder treeBuilder, ZKDatabase zkDb, QuorumPeer self)
        throws IOException
    {
<span class="fc" id="L39">        super(logFactory, tickTime, minSessionTimeout, maxSessionTimeout,</span>
                treeBuilder, zkDb, self);
<span class="fc" id="L41">    }</span>

    /**
     * Abstract method to return the learner associated with this server.
     * Since the Learner may change under our feet (when QuorumPeer reassigns
     * it) we can't simply take a reference here. Instead, we need the 
     * subclasses to implement this.     
     */
    abstract public Learner getLearner();        
    
    /**
     * Returns the current state of the session tracker. This is only currently
     * used by a Learner to build a ping response packet.
     * 
     */
    protected HashMap&lt;Long, Integer&gt; getTouchSnapshot() {
<span class="pc bpc" id="L57" title="1 of 2 branches missed.">        if (sessionTracker != null) {</span>
<span class="fc" id="L58">            return ((LearnerSessionTracker) sessionTracker).snapshot();</span>
        }
<span class="nc" id="L60">        return new HashMap&lt;Long, Integer&gt;();</span>
    }
    
    /**
     * Returns the id of the associated QuorumPeer, which will do for a unique
     * id of this server. 
     */
    @Override
    public long getServerId() {
<span class="fc" id="L69">        return self.getId();</span>
    }    
    
    @Override
    public void createSessionTracker() {
<span class="fc" id="L74">        sessionTracker = new LearnerSessionTracker(this, getZKDatabase()</span>
<span class="fc" id="L75">                .getSessionWithTimeOuts(), self.getId(),</span>
<span class="fc" id="L76">                getZooKeeperServerListener());</span>
<span class="fc" id="L77">    }</span>
    
    @Override
<span class="fc" id="L80">    protected void startSessionTracker() {}</span>
    
    @Override
    protected void revalidateSession(ServerCnxn cnxn, long sessionId,
            int sessionTimeout) throws IOException {
<span class="fc" id="L85">        getLearner().validateSession(cnxn, sessionId, sessionTimeout);</span>
<span class="fc" id="L86">    }</span>
    
    @Override
    protected void registerJMX() {
        // register with JMX
        try {
<span class="fc" id="L92">            jmxDataTreeBean = new DataTreeBean(getZKDatabase().getDataTree());</span>
<span class="fc" id="L93">            MBeanRegistry.getInstance().register(jmxDataTreeBean, jmxServerBean);</span>
<span class="fc" id="L94">        } catch (Exception e) {</span>
<span class="fc" id="L95">            LOG.warn(&quot;Failed to register with JMX&quot;, e);</span>
<span class="fc" id="L96">            jmxDataTreeBean = null;</span>
<span class="fc" id="L97">        }</span>
<span class="fc" id="L98">    }</span>

    public void registerJMX(ZooKeeperServerBean serverBean,
            LocalPeerBean localPeerBean)
    {
        // register with JMX
<span class="pc bpc" id="L104" title="1 of 2 branches missed.">        if (self.jmxLeaderElectionBean != null) {</span>
            try {
<span class="nc" id="L106">                MBeanRegistry.getInstance().unregister(self.jmxLeaderElectionBean);</span>
<span class="nc" id="L107">            } catch (Exception e) {</span>
<span class="nc" id="L108">                LOG.warn(&quot;Failed to register with JMX&quot;, e);</span>
<span class="nc" id="L109">            }</span>
<span class="nc" id="L110">            self.jmxLeaderElectionBean = null;</span>
        }

        try {
<span class="fc" id="L114">            jmxServerBean = serverBean;</span>
<span class="fc" id="L115">            MBeanRegistry.getInstance().register(serverBean, localPeerBean);</span>
<span class="fc" id="L116">        } catch (Exception e) {</span>
<span class="fc" id="L117">            LOG.warn(&quot;Failed to register with JMX&quot;, e);</span>
<span class="fc" id="L118">            jmxServerBean = null;</span>
<span class="fc" id="L119">        }</span>
<span class="fc" id="L120">    }</span>

    @Override
    protected void unregisterJMX() {
        // unregister from JMX
        try {
<span class="fc bfc" id="L126" title="All 2 branches covered.">            if (jmxDataTreeBean != null) {</span>
<span class="fc" id="L127">                MBeanRegistry.getInstance().unregister(jmxDataTreeBean);</span>
            }
<span class="nc" id="L129">        } catch (Exception e) {</span>
<span class="nc" id="L130">            LOG.warn(&quot;Failed to unregister with JMX&quot;, e);</span>
<span class="fc" id="L131">        }</span>
<span class="fc" id="L132">        jmxDataTreeBean = null;</span>
<span class="fc" id="L133">    }</span>

    protected void unregisterJMX(Learner peer) {
        // unregister from JMX
        try {
<span class="fc bfc" id="L138" title="All 2 branches covered.">            if (jmxServerBean != null) {</span>
<span class="fc" id="L139">                MBeanRegistry.getInstance().unregister(jmxServerBean);</span>
            }
<span class="nc" id="L141">        } catch (Exception e) {</span>
<span class="nc" id="L142">            LOG.warn(&quot;Failed to unregister with JMX&quot;, e);</span>
<span class="fc" id="L143">        }</span>
<span class="fc" id="L144">        jmxServerBean = null;</span>
<span class="fc" id="L145">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>